function createMayaScene(K,R,t,img)

s = 100;

if (isstr(img))
    file = img;
    img = imread(file);
else
    file = 'imagePlane.jpg';
    imwrite(img,file);
end

w = size(img,2);
h = size(img,1);

T = [R t; 0 0 0 1];
T = inv(T');

f = K(1,1)/s*25.4;
ax = w/s;
ay = h/s;
ox = (w/2-K(1,3))/s;
oy = -(h/2-K(2,3))/s;

fid = fopen('setupScene.mel','w');

fprintf(fid, ...
['// create calibration grid\n' ... 
'string $planeNodes[] = `polyPlane -w 150 -h 210 -sx 5 -sy 7 -ax 0 0 1`;\n' ...
'string $planeName = $planeNodes[0];\n' ...
'setAttr ($planeName + ".translateX") 75;\n' ...
'setAttr ($planeName + ".translateY") 105;\n' ...
'\n' ...
'// create camera\n' ...
'string $cameraNodes[] = `camera -focalLength %f -horizontalFilmAperture %f -verticalFilmAperture %f -horizontalFilmOffset %f -verticalFilmOffset %f -filmFit Horizontal -nearClipPlane 0.01 -farClipPlane 1000`;\n' ...
'string $cameraTransform = $cameraNodes[0];\n' ...
'string $cameraShape = $cameraNodes[1];\n' ...
'xform -rotation 180 0 0 $cameraTransform;\n' ...
'xform -r -m\n' ...
'	%f %f %f %f\n' ...
'	%f %f %f %f\n' ...
'	%f %f %f %f\n' ...
'	%f %f %f %f\n' ...
'	$cameraTransform;\n' ...
'string $imagePlane = `createNode imagePlane`;\n' ...
'cameraImagePlaneUpdate ($cameraShape, $imagePlane);\n' ...
'setAttr ($imagePlane + ".offsetX") %f;\n' ...
'setAttr ($imagePlane + ".offsetY") %f;\n' ...
'setAttr ($imagePlane + ".imageName") -type "string" "%s";\n' ...
'setAttr ($imagePlane + ".fit") 4;\n' ...
'setAttr ($imagePlane + ".displayOnlyIfCurrent") 1;\n' ...
'setAttr ($imagePlane + ".depth") 900;'], ...
f,ax,ay,ox,oy,T(1,1),T(1,2),T(1,3),T(1,4),T(2,1),T(2,2),T(2,3),T(2,4),T(3,1),T(3,2),T(3,3),T(3,4),T(4,1),T(4,2),T(4,3),T(4,4),ox,oy,file);

fclose(fid);